/* Wordpress.c generated by valac, the Vala compiler
 * generated from Wordpress.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>


#define TYPE_WORDPRESS (wordpress_get_type ())
#define WORDPRESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORDPRESS, Wordpress))
#define WORDPRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORDPRESS, WordpressClass))
#define IS_WORDPRESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORDPRESS))
#define IS_WORDPRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORDPRESS))
#define WORDPRESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORDPRESS, WordpressClass))

typedef struct _Wordpress Wordpress;
typedef struct _WordpressClass WordpressClass;
typedef struct _WordpressPrivate WordpressPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _Wordpress {
	GObject parent_instance;
	WordpressPrivate * priv;
	char* password;
	char* server;
};

struct _WordpressClass {
	GObjectClass parent_class;
};

struct _WordpressPrivate {
	char* _username;
};


static gpointer wordpress_parent_class = NULL;

GType wordpress_get_type (void);
#define WORDPRESS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_WORDPRESS, WordpressPrivate))
enum  {
	WORDPRESS_DUMMY_PROPERTY,
	WORDPRESS_USERNAME
};
void wordpress_set_username (Wordpress* self, const char* value);
void wordpress_set_details (Wordpress* self, const char* name, const char* pass, const char* serv);
const char* wordpress_get_username (Wordpress* self);
char* wordpress_post (Wordpress* self, GHashTable* content, gboolean publish);
char* wordpress_update (Wordpress* self, const char* pid, GHashTable* content, gboolean publish);
static GValue* _g_value_dup (GValue* self);
char* wordpress_upload_file (Wordpress* self, GHashTable* data);
void wordpress_add_category (Wordpress* self, const char* category);
GHashTable* wordpress_get_last_post (Wordpress* self);
gboolean wordpress_get_posts (Wordpress* self);
static void _vala_array_add1 (char*** array, int* length, int* size, char* value);
char** wordpress_get_categories (Wordpress* self, int* result_length1);
Wordpress* wordpress_new (void);
Wordpress* wordpress_construct (GType object_type);
static void wordpress_finalize (GObject* obj);
static void wordpress_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void wordpress_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);



void wordpress_set_details (Wordpress* self, const char* name, const char* pass, const char* serv) {
	char* _tmp0_;
	char* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (pass != NULL);
	g_return_if_fail (serv != NULL);
	wordpress_set_username (self, name);
	self->password = (_tmp0_ = g_strdup (pass), _g_free0 (self->password), _tmp0_);
	self->server = (_tmp1_ = g_strdup (serv), _g_free0 (self->server), _tmp1_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


char* wordpress_post (Wordpress* self, GHashTable* content, gboolean publish) {
	char* result;
	GError * _inner_error_;
	SoupMessage* message;
	SoupSessionAsync* session;
	char* data;
	GValue _tmp0_ = {0};
	GValue v;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (content != NULL, NULL);
	_inner_error_ = NULL;
	message = _g_object_ref0 (soup_xmlrpc_request_new (self->server, "metaWeblog.newPost", G_TYPE_INT, 1, G_TYPE_STRING, self->priv->_username, G_TYPE_STRING, self->password, G_TYPE_HASH_TABLE, content, G_TYPE_BOOLEAN, publish, G_TYPE_INVALID));
	session = (SoupSessionAsync*) soup_session_async_new ();
	soup_session_send_message ((SoupSession*) session, message);
	data = g_strdup (soup_message_body_flatten (message->response_body)->data);
	v = (g_value_init (&_tmp0_, G_TYPE_STRING), _tmp0_);
	{
		soup_xmlrpc_parse_method_response (data, -1, &v, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_signal_emit_by_name (self, "password-error", e->message);
			result = g_strdup ("None");
			_g_error_free0 (e);
			_g_object_unref0 (message);
			_g_object_unref0 (session);
			_g_free0 (data);
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			return result;
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (data);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = g_strconcat ("Message posted with ID ", g_value_get_string (&v), NULL);
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (data);
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	return result;
}


char* wordpress_update (Wordpress* self, const char* pid, GHashTable* content, gboolean publish) {
	char* result;
	GError * _inner_error_;
	SoupMessage* message;
	SoupSessionAsync* session;
	char* data;
	GValue _tmp0_ = {0};
	GValue v;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (pid != NULL, NULL);
	g_return_val_if_fail (content != NULL, NULL);
	_inner_error_ = NULL;
	message = _g_object_ref0 (soup_xmlrpc_request_new (self->server, "metaWeblog.editPost", G_TYPE_STRING, pid, G_TYPE_STRING, self->priv->_username, G_TYPE_STRING, self->password, G_TYPE_HASH_TABLE, content, G_TYPE_BOOLEAN, publish, G_TYPE_INVALID));
	session = (SoupSessionAsync*) soup_session_async_new ();
	soup_session_send_message ((SoupSession*) session, message);
	data = g_strdup (soup_message_body_flatten (message->response_body)->data);
	v = (g_value_init (&_tmp0_, G_TYPE_BOOLEAN), _tmp0_);
	{
		soup_xmlrpc_parse_method_response (data, -1, &v, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_signal_emit_by_name (self, "password-error", e->message);
			result = g_strdup ("None");
			_g_error_free0 (e);
			_g_object_unref0 (message);
			_g_object_unref0 (session);
			_g_free0 (data);
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			return result;
		}
	}
	__finally3:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (data);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	if (g_value_get_boolean (&v)) {
		result = g_strdup ("Post updated");
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (data);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		return result;
	} else {
		result = g_strdup ("None");
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (data);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		return result;
	}
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (data);
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


char* wordpress_upload_file (Wordpress* self, GHashTable* data) {
	char* result;
	GError * _inner_error_;
	SoupMessage* message;
	SoupSessionAsync* session;
	char* returndata;
	GValue _tmp0_ = {0};
	GValue v;
	GHashTable* hash;
	GValue* x;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_inner_error_ = NULL;
	message = _g_object_ref0 (soup_xmlrpc_request_new (self->server, "wp.uploadFile", G_TYPE_INT, 1, G_TYPE_STRING, self->priv->_username, G_TYPE_STRING, self->password, G_TYPE_HASH_TABLE, data, G_TYPE_INVALID));
	session = (SoupSessionAsync*) soup_session_async_new ();
	soup_session_send_message ((SoupSession*) session, message);
	returndata = g_strdup (soup_message_body_flatten (message->response_body)->data);
	v = (g_value_init (&_tmp0_, G_TYPE_HASH_TABLE), _tmp0_);
	{
		soup_xmlrpc_parse_method_response (returndata, -1, &v, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_signal_emit_by_name (self, "password-error", e->message);
			result = g_strdup ("");
			_g_error_free0 (e);
			_g_object_unref0 (message);
			_g_object_unref0 (session);
			_g_free0 (returndata);
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			return result;
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (returndata);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	hash = _g_hash_table_ref0 (g_value_get_boxed (&v));
	x = __g_value_dup0 ((GValue*) g_hash_table_lookup (hash, "url"));
	result = g_strdup (g_value_get_string (x));
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (returndata);
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	_g_hash_table_unref0 (hash);
	_g_free0 (x);
	return result;
}


void wordpress_add_category (Wordpress* self, const char* category) {
	SoupMessage* message;
	SoupSessionSync* session;
	char* data;
	g_return_if_fail (self != NULL);
	g_return_if_fail (category != NULL);
	message = _g_object_ref0 (soup_xmlrpc_request_new (self->server, "wp.newCategory", G_TYPE_INT, 1, G_TYPE_STRING, self->priv->_username, G_TYPE_STRING, self->password, G_TYPE_STRING, category, G_TYPE_INVALID));
	session = (SoupSessionSync*) soup_session_sync_new ();
	soup_session_send_message ((SoupSession*) session, message);
	data = g_strdup (soup_message_body_flatten (message->response_body)->data);
	g_debug ("Wordpress.vala:78: %s", data);
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (data);
}


GHashTable* wordpress_get_last_post (Wordpress* self) {
	GHashTable* result;
	GError * _inner_error_;
	SoupMessage* message;
	SoupSessionAsync* session;
	guint return_code;
	char* data;
	GValueArray* v3;
	GValue _tmp0_ = {0};
	GValue v;
	GHashTable* hash;
	g_return_val_if_fail (self != NULL, NULL);
	_inner_error_ = NULL;
	message = _g_object_ref0 (soup_xmlrpc_request_new (self->server, "metaWeblog.getRecentPosts", G_TYPE_INT, 1, G_TYPE_STRING, self->priv->_username, G_TYPE_STRING, self->password, G_TYPE_INT, 1, G_TYPE_INVALID));
	session = (SoupSessionAsync*) soup_session_async_new ();
	return_code = soup_session_send_message ((SoupSession*) session, message);
	if (return_code == 2) {
		g_signal_emit_by_name (self, "password-error", "Please check your network");
		result = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		return result;
	}
	data = g_strdup (soup_message_body_flatten (message->response_body)->data);
	v3 = NULL;
	v = (g_value_init (&_tmp0_, G_TYPE_VALUE_ARRAY), _tmp0_);
	{
		soup_xmlrpc_parse_method_response (data, -1, &v, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch5_g_error;
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_signal_emit_by_name (self, "password-error", e->message);
			result = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
			_g_error_free0 (e);
			_g_object_unref0 (message);
			_g_object_unref0 (session);
			_g_free0 (data);
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			return result;
		}
	}
	__finally5:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (data);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	v3 = g_value_get_boxed (&v);
	hash = _g_hash_table_ref0 (g_value_get_boxed (g_value_array_get_nth (v3, (guint) 0)));
	result = hash;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (data);
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	return result;
}


gboolean wordpress_get_posts (Wordpress* self) {
	gboolean result;
	GError * _inner_error_;
	SoupMessage* message;
	SoupSessionAsync* session;
	guint return_code;
	char* data;
	GValueArray* v3;
	GValue _tmp0_ = {0};
	GValue v;
	g_return_val_if_fail (self != NULL, FALSE);
	_inner_error_ = NULL;
	message = _g_object_ref0 (soup_xmlrpc_request_new (self->server, "metaWeblog.getRecentPosts", G_TYPE_INT, 1, G_TYPE_STRING, self->priv->_username, G_TYPE_STRING, self->password, G_TYPE_INT, 10, G_TYPE_INVALID));
	session = (SoupSessionAsync*) soup_session_async_new ();
	return_code = soup_session_send_message ((SoupSession*) session, message);
	if (return_code == 2) {
		g_signal_emit_by_name (self, "password-error", "Please check your network");
		result = FALSE;
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		return result;
	}
	data = g_strdup (soup_message_body_flatten (message->response_body)->data);
	v3 = NULL;
	v = (g_value_init (&_tmp0_, G_TYPE_VALUE_ARRAY), _tmp0_);
	{
		soup_xmlrpc_parse_method_response (data, -1, &v, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_signal_emit_by_name (self, "password-error", e->message);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (message);
			_g_object_unref0 (session);
			_g_free0 (data);
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			return result;
		}
	}
	__finally6:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (data);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	v3 = g_value_get_boxed (&v);
	if (v3 != NULL) {
		g_signal_emit_by_name (self, "get-old-posts", v3);
		result = FALSE;
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (data);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		return result;
	}
	result = TRUE;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (data);
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	return result;
}


static void _vala_array_add1 (char*** array, int* length, int* size, char* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (char*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


char** wordpress_get_categories (Wordpress* self, int* result_length1) {
	char** result;
	GError * _inner_error_;
	SoupMessage* message;
	SoupSessionAsync* session;
	guint return_code;
	char* data;
	GValueArray* v3;
	GValue _tmp2_ = {0};
	GValue v;
	char** _tmp6_;
	gint _result__size;
	gint _result__length1;
	char** _tmp5_ = NULL;
	char** _result_;
	char** _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_inner_error_ = NULL;
	message = _g_object_ref0 (soup_xmlrpc_request_new (self->server, "wp.getCategories", G_TYPE_INT, 1, G_TYPE_STRING, self->priv->_username, G_TYPE_STRING, self->password, G_TYPE_INVALID));
	session = (SoupSessionAsync*) soup_session_async_new ();
	return_code = soup_session_send_message ((SoupSession*) session, message);
	if (return_code == 2) {
		char** _tmp0_ = NULL;
		char** _tmp1_;
		g_signal_emit_by_name (self, "password-error", "Please check your network");
		result = (_tmp1_ = (_tmp0_ = g_new0 (char*, 0 + 1), _tmp0_), *result_length1 = 0, _tmp1_);
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		return result;
	}
	data = g_strdup (soup_message_body_flatten (message->response_body)->data);
	v3 = NULL;
	v = (g_value_init (&_tmp2_, G_TYPE_VALUE_ARRAY), _tmp2_);
	{
		soup_xmlrpc_parse_method_response (data, -1, &v, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char** _tmp3_ = NULL;
			char** _tmp4_;
			g_signal_emit_by_name (self, "password-error", e->message);
			result = (_tmp4_ = (_tmp3_ = g_new0 (char*, 0 + 1), _tmp3_), *result_length1 = 0, _tmp4_);
			_g_error_free0 (e);
			_g_object_unref0 (message);
			_g_object_unref0 (session);
			_g_free0 (data);
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			return result;
			_g_error_free0 (e);
		}
	}
	__finally7:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (data);
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	v3 = g_value_get_boxed (&v);
	_result_ = (_tmp6_ = (_tmp5_ = g_new0 (char*, 0 + 1), _tmp5_), _result__length1 = 0, _result__size = _result__length1, _tmp6_);
	{
		gint i;
		i = 0;
		{
			gboolean _tmp7_;
			_tmp7_ = TRUE;
			while (TRUE) {
				GHashTable* hash;
				GValue* x;
				if (!_tmp7_) {
					i++;
				}
				_tmp7_ = FALSE;
				if (!(i < v3->n_values)) {
					break;
				}
				hash = _g_hash_table_ref0 (g_value_get_boxed (g_value_array_get_nth (v3, (guint) i)));
				x = __g_value_dup0 ((GValue*) g_hash_table_lookup (hash, "description"));
				_vala_array_add1 (&_result_, &_result__length1, &_result__size, g_strdup (g_value_get_string (x)));
				_g_hash_table_unref0 (hash);
				_g_free0 (x);
			}
		}
	}
	result = (_tmp8_ = _result_, *result_length1 = _result__length1, _tmp8_);
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (data);
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	return result;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (data);
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_free), NULL);
}


Wordpress* wordpress_construct (GType object_type) {
	Wordpress * self;
	self = (Wordpress*) g_object_new (object_type, NULL);
	return self;
}


Wordpress* wordpress_new (void) {
	return wordpress_construct (TYPE_WORDPRESS);
}


const char* wordpress_get_username (Wordpress* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_username;
	return result;
}


void wordpress_set_username (Wordpress* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_username = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_username), _tmp0_);
	g_object_notify ((GObject *) self, "username");
}


static void wordpress_class_init (WordpressClass * klass) {
	wordpress_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (WordpressPrivate));
	G_OBJECT_CLASS (klass)->get_property = wordpress_get_property;
	G_OBJECT_CLASS (klass)->set_property = wordpress_set_property;
	G_OBJECT_CLASS (klass)->finalize = wordpress_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORDPRESS_USERNAME, g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("password_error", TYPE_WORDPRESS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("get_old_posts", TYPE_WORDPRESS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_VALUE_ARRAY);
}


static void wordpress_instance_init (Wordpress * self) {
	self->priv = WORDPRESS_GET_PRIVATE (self);
}


static void wordpress_finalize (GObject* obj) {
	Wordpress * self;
	self = WORDPRESS (obj);
	_g_free0 (self->priv->_username);
	_g_free0 (self->password);
	_g_free0 (self->server);
	G_OBJECT_CLASS (wordpress_parent_class)->finalize (obj);
}


GType wordpress_get_type (void) {
	static GType wordpress_type_id = 0;
	if (wordpress_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (WordpressClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wordpress_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Wordpress), 0, (GInstanceInitFunc) wordpress_instance_init, NULL };
		wordpress_type_id = g_type_register_static (G_TYPE_OBJECT, "Wordpress", &g_define_type_info, 0);
	}
	return wordpress_type_id;
}


static void wordpress_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Wordpress * self;
	self = WORDPRESS (object);
	switch (property_id) {
		case WORDPRESS_USERNAME:
		g_value_set_string (value, wordpress_get_username (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void wordpress_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Wordpress * self;
	self = WORDPRESS (object);
	switch (property_id) {
		case WORDPRESS_USERNAME:
		wordpress_set_username (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}




